/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.enums.EnumLogictype;
import de.ship.db.tables.records.VCoreLogicchainRecord;

import java.time.LocalDateTime;
import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class VCoreLogicchain extends TableImpl<VCoreLogicchainRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.v_core_logicchain</code>
     */
    public static final VCoreLogicchain V_CORE_LOGICCHAIN = new VCoreLogicchain();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<VCoreLogicchainRecord> getRecordType() {
        return VCoreLogicchainRecord.class;
    }

    /**
     * The column <code>common_dd.v_core_logicchain.lastchange</code>.
     */
    public final TableField<VCoreLogicchainRecord, LocalDateTime> LASTCHANGE = createField(DSL.name("lastchange"), SQLDataType.LOCALDATETIME(6), this, "");

    /**
     * The column <code>common_dd.v_core_logicchain.pk</code>.
     */
    public final TableField<VCoreLogicchainRecord, Integer> PK = createField(DSL.name("pk"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_core_logicchain.logictype</code>.
     */
    public final TableField<VCoreLogicchainRecord, EnumLogictype> LOGICTYPE = createField(DSL.name("logictype"), SQLDataType.VARCHAR.asEnumDataType(EnumLogictype.class), this, "");

    /**
     * The column <code>common_dd.v_core_logicchain.fk_orgrp</code>.
     */
    public final TableField<VCoreLogicchainRecord, Integer> FK_ORGRP = createField(DSL.name("fk_orgrp"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_core_logicchain.fk_element</code>.
     */
    public final TableField<VCoreLogicchainRecord, Integer> FK_ELEMENT = createField(DSL.name("fk_element"), SQLDataType.INTEGER, this, "");

    private VCoreLogicchain(Name alias, Table<VCoreLogicchainRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private VCoreLogicchain(Name alias, Table<VCoreLogicchainRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.view("""
        create view "v_core_logicchain" as  SELECT lastchange,
         pk_core_logic AS pk,
             CASE fk_logictype
                 WHEN 1 THEN 'logictype.dependency'::common_dd.enum_logictype
                 WHEN 2 THEN 'logictype.validation.error'::common_dd.enum_logictype
                 WHEN 3 THEN 'logictype.validation.warn'::common_dd.enum_logictype
                 WHEN 4 THEN 'logictype.jump'::common_dd.enum_logictype
                 WHEN 5 THEN 'logictype.jump.abort'::common_dd.enum_logictype
                 ELSE NULL::common_dd.enum_logictype
             END AS logictype,
         fk_orgrp,
         fk_variable AS fk_element
        FROM common_dd.t_core_logic;
        """), where);
    }

    /**
     * Create an aliased <code>common_dd.v_core_logicchain</code> table
     * reference
     */
    public VCoreLogicchain(String alias) {
        this(DSL.name(alias), V_CORE_LOGICCHAIN);
    }

    /**
     * Create an aliased <code>common_dd.v_core_logicchain</code> table
     * reference
     */
    public VCoreLogicchain(Name alias) {
        this(alias, V_CORE_LOGICCHAIN);
    }

    /**
     * Create a <code>common_dd.v_core_logicchain</code> table reference
     */
    public VCoreLogicchain() {
        this(DSL.name("v_core_logicchain"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public VCoreLogicchain as(String alias) {
        return new VCoreLogicchain(DSL.name(alias), this);
    }

    @Override
    public VCoreLogicchain as(Name alias) {
        return new VCoreLogicchain(alias, this);
    }

    @Override
    public VCoreLogicchain as(Table<?> alias) {
        return new VCoreLogicchain(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreLogicchain rename(String name) {
        return new VCoreLogicchain(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreLogicchain rename(Name name) {
        return new VCoreLogicchain(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreLogicchain rename(Table<?> name) {
        return new VCoreLogicchain(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreLogicchain where(Condition condition) {
        return new VCoreLogicchain(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreLogicchain where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreLogicchain where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreLogicchain where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreLogicchain where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreLogicchain where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreLogicchain where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreLogicchain where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreLogicchain whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreLogicchain whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
